"use strict";
exports.__esModule = true;
var composeFa_1 = require("../composeFa");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFa_1.composeFa.length).toStrictEqual(1);
        expect(composeFa_1.composeFa(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFa_1.composeFa(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFa_1.composeFa)(utilities_1.fn1)(utilities_1.a)).toStrictEqual(composeFa_1.composeFa(utilities_1.identity(utilities_1.fn1))(utilities_1.a));
    });
    test("Symbol", function () {
        expect(composeFa_1.composeFa(utilities_1.fn1)(utilities_1.a)).toStrictEqual(composeFa_1.composeFa(utilities_1.fn1)(utilities_1.a));
        expect(composeFa_1.composeFa(utilities_1.fn1)(utilities_1.a)).not.toStrictEqual(composeFa_1.composeFa(utilities_1.fn1)(utilities_1.b));
    });
});
//# sourceMappingURL=composeFa.spec.js.map