"use strict";
exports.__esModule = true;
var composeFab_1 = require("../composeFab");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFab_1.composeFab.length).toStrictEqual(1);
        expect(composeFab_1.composeFab(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFab_1.composeFab)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFab_1.composeFab(utilities_1.identity(utilities_1.fn2))(utilities_1.a)(utilities_1.b));
    });
    test("Symbol", function () {
        expect(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.a)(utilities_1.b));
        expect(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).not.toStrictEqual(composeFab_1.composeFab(utilities_1.fn2)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFab.spec.js.map