"use strict";
exports.__esModule = true;
var composeFabc_1 = require("../composeFabc");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFabc_1.composeFabc.length).toStrictEqual(1);
        expect(composeFabc_1.composeFabc(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFabc_1.composeFabc(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFabc_1.composeFabc(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFabc_1.composeFabc(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFabc_1.composeFabc)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFabc_1.composeFabc(utilities_1.identity(utilities_1.fn3))(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFabc_1.composeFabc(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFabc_1.composeFabc(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFabc_1.composeFabc(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFabc_1.composeFabc(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFabc.spec.js.map