"use strict";
exports.__esModule = true;
var composeFba_1 = require("../composeFba");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFba_1.composeFba.length).toStrictEqual(1);
        expect(composeFba_1.composeFba(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFba_1.composeFba)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFba_1.composeFba(utilities_1.identity(utilities_1.fn2))(utilities_1.a)(utilities_1.b));
    });
    test("Symbol", function () {
        expect(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.a)(utilities_1.b));
        expect(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).not.toStrictEqual(composeFba_1.composeFba(utilities_1.fn2)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFba.spec.js.map