"use strict";
exports.__esModule = true;
var composeFbac_1 = require("../composeFbac");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFbac_1.composeFbac.length).toStrictEqual(1);
        expect(composeFbac_1.composeFbac(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFbac_1.composeFbac(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFbac_1.composeFbac(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFbac_1.composeFbac(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFbac_1.composeFbac)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFbac_1.composeFbac(utilities_1.identity(utilities_1.fn3))(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFbac_1.composeFbac(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFbac_1.composeFbac(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFbac_1.composeFbac(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFbac_1.composeFbac(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFbac.spec.js.map