"use strict";
exports.__esModule = true;
var composeFbca_1 = require("../composeFbca");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFbca_1.composeFbca.length).toStrictEqual(1);
        expect(composeFbca_1.composeFbca(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFbca_1.composeFbca(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFbca_1.composeFbca(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFbca_1.composeFbca(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFbca_1.composeFbca)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFbca_1.composeFbca(utilities_1.identity(utilities_1.fn3))(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFbca_1.composeFbca(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFbca_1.composeFbca(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFbca_1.composeFbca(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFbca_1.composeFbca(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFbca.spec.js.map