"use strict";
exports.__esModule = true;
var composeFcab_1 = require("../composeFcab");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFcab_1.composeFcab.length).toStrictEqual(1);
        expect(composeFcab_1.composeFcab(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFcab_1.composeFcab)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFcab_1.composeFcab(utilities_1.identity(utilities_1.fn3))(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFcab_1.composeFcab(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFcab.spec.js.map