"use strict";
exports.__esModule = true;
var composeFcba_1 = require("../composeFcba");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFcba_1.composeFcba.length).toStrictEqual(1);
        expect(composeFcba_1.composeFcba(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFcba_1.composeFcba(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFcba_1.composeFcba(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFcba_1.composeFcba(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFcba_1.composeFcba)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFcba_1.composeFcba(utilities_1.identity(utilities_1.fn3))(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFcba_1.composeFcba(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFcba_1.composeFcba(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFcba_1.composeFcba(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFcba_1.composeFcba(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFcba.spec.js.map