"use strict";
exports.__esModule = true;
var composeFgGa_1 = require("../composeFgGa");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgGa_1.composeFgGa.length).toStrictEqual(1);
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgGa_1.composeFgGa)(utilities_1.fn1)(utilities_1.fn1)(utilities_1.a)).toStrictEqual(composeFgGa_1.composeFgGa(utilities_1.identity(utilities_1.fn1))(utilities_1.fn1)(utilities_1.a));
    });
    test("Symbol", function () {
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.identity)(utilities_1.a)).toStrictEqual(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.identity)(utilities_1.a));
        expect(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.identity)(utilities_1.a)).not.toStrictEqual(composeFgGa_1.composeFgGa(utilities_1.fn1)(utilities_1.identity)(utilities_1.b));
    });
});
//# sourceMappingURL=composeFgGa.spec.js.map