"use strict";
exports.__esModule = true;
var composeFgGab_1 = require("../composeFgGab");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgGab_1.composeFgGab.length).toStrictEqual(1);
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgGab_1.composeFgGab)(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgGab_1.composeFgGab(utilities_1.identity(utilities_1.fn1))(utilities_1.fn2)(utilities_1.a)(utilities_1.b));
    });
    test("Symbol", function () {
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a)(utilities_1.b));
        expect(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).not.toStrictEqual(composeFgGab_1.composeFgGab(utilities_1.fn1)(utilities_1.fn2)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgGab.spec.js.map