"use strict";
exports.__esModule = true;
var composeFgGabc_1 = require("../composeFgGabc");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgGabc_1.composeFgGabc.length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(1);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgGabc_1.composeFgGabc)(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgGabc_1.composeFgGabc(utilities_1.identity(utilities_1.fn1))(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFgGabc_1.composeFgGabc(utilities_1.fn1)(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgGabc.spec.js.map