"use strict";
exports.__esModule = true;
var composeFgaGa_1 = require("../composeFgaGa");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgaGa_1.composeFgaGa.length).toStrictEqual(1);
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgaGa_1.composeFgaGa)(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)).toStrictEqual(composeFgaGa_1.composeFgaGa(utilities_1.identity(utilities_1.fn2))(utilities_1.fn1)(utilities_1.a));
    });
    test("Symbol", function () {
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)).toStrictEqual(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a));
        expect(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)).not.toStrictEqual(composeFgaGa_1.composeFgaGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.b));
    });
});
//# sourceMappingURL=composeFgaGa.spec.js.map