"use strict";
exports.__esModule = true;
var composeFgaGab_1 = require("../composeFgaGab");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgaGab_1.composeFgaGab.length).toStrictEqual(1);
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgaGab_1.composeFgaGab)(utilities_1.fn2)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgaGab_1.composeFgaGab(utilities_1.identity(utilities_1.fn2))(utilities_1.fn2)(utilities_1.a)(utilities_1.b));
    });
    test("Symbol", function () {
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.a)(utilities_1.b));
        expect(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).not.toStrictEqual(composeFgaGab_1.composeFgaGab(utilities_1.fn2)(utilities_1.fn2)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgaGab.spec.js.map