"use strict";
exports.__esModule = true;
var composeFgaGabc_1 = require("../composeFgaGabc");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgaGabc_1.composeFgaGabc.length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgaGabc_1.composeFgaGabc)(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgaGabc_1.composeFgaGabc(utilities_1.identity(utilities_1.fn2))(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFgaGabc_1.composeFgaGabc(utilities_1.fn2)(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgaGabc.spec.js.map