"use strict";
exports.__esModule = true;
var composeFgaGb_1 = require("../composeFgaGb");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgaGb_1.composeFgaGb.length).toStrictEqual(1);
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgaGb_1.composeFgaGb)(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgaGb_1.composeFgaGb(utilities_1.identity(utilities_1.fn2))(utilities_1.fn1)(utilities_1.a)(utilities_1.b));
    });
    test("Symbol", function () {
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b));
        expect(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).not.toStrictEqual(composeFgaGb_1.composeFgaGb(utilities_1.fn2)(utilities_1.fn1)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgaGb.spec.js.map