"use strict";
exports.__esModule = true;
var composeFgabGa_1 = require("../composeFgabGa");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgabGa_1.composeFgabGa.length).toStrictEqual(1);
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgabGa_1.composeFgabGa)(utilities_1.fn3)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgabGa_1.composeFgabGa(utilities_1.identity(utilities_1.fn3))(utilities_1.fn1)(utilities_1.a)(utilities_1.b));
    });
    test("Symbol", function () {
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.a)(utilities_1.b));
        expect(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).not.toStrictEqual(composeFgabGa_1.composeFgabGa(utilities_1.fn3)(utilities_1.fn1)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgabGa.spec.js.map