"use strict";
exports.__esModule = true;
var composeFgabGab_1 = require("../composeFgabGab");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgabGab_1.composeFgabGab.length).toStrictEqual(1);
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgabGab_1.composeFgabGab)(utilities_1.fn3)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgabGab_1.composeFgabGab(utilities_1.identity(utilities_1.fn3))(utilities_1.fn2)(utilities_1.a)(utilities_1.b));
    });
    test("Symbol", function () {
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.a)(utilities_1.b));
        expect(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).not.toStrictEqual(composeFgabGab_1.composeFgabGab(utilities_1.fn3)(utilities_1.fn2)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgabGab.spec.js.map