"use strict";
exports.__esModule = true;
var composeFgabGabc_1 = require("../composeFgabGabc");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgabGabc_1.composeFgabGabc.length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(3);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgabGabc_1.composeFgabGabc)(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabGabc_1.composeFgabGabc(utilities_1.identity(utilities_1.fn3))(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFgabGabc_1.composeFgabGabc(utilities_1.fn3)(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgabGabc.spec.js.map