"use strict";
exports.__esModule = true;
var composeFgabcGa_1 = require("../composeFgabcGa");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgabcGa_1.composeFgabcGa.length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4).length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(4);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgabcGa_1.composeFgabcGa)(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGa_1.composeFgabcGa(utilities_1.identity(utilities_1.fn4))(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFgabcGa_1.composeFgabcGa(utilities_1.fn4)(utilities_1.fn1)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgabcGa.spec.js.map