"use strict";
exports.__esModule = true;
var composeFgabcGab_1 = require("../composeFgabcGab");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgabcGab_1.composeFgabcGab.length).toStrictEqual(1);
        expect(composeFgabcGab_1.composeFgabcGab(utilities_1.fn4).length).toStrictEqual(1);
        expect(composeFgabcGab_1.composeFgabcGab(utilities_1.fn4)(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgabcGab_1.composeFgabcGab(utilities_1.fn4)(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabcGab_1.composeFgabcGab(utilities_1.fn4)(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgabcGab_1.composeFgabcGab(utilities_1.fn4)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(4);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgabcGab_1.composeFgabcGab)(utilities_1.fn4)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGab_1.composeFgabcGab(utilities_1.identity(utilities_1.fn4))(utilities_1.fn2)(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFgabcGab_1.composeFgabcGab(utilities_1.fn4)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGab_1.composeFgabcGab(utilities_1.fn4)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFgabcGab_1.composeFgabcGab(utilities_1.fn4)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFgabcGab_1.composeFgabcGab(utilities_1.fn4)(utilities_1.fn2)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgabcGab.spec.js.map