"use strict";
exports.__esModule = true;
var composeFgabcGabc_1 = require("../composeFgabcGabc");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgabcGabc_1.composeFgabcGabc.length).toStrictEqual(1);
        expect(composeFgabcGabc_1.composeFgabcGabc(utilities_1.fn4).length).toStrictEqual(1);
        expect(composeFgabcGabc_1.composeFgabcGabc(utilities_1.fn4)(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgabcGabc_1.composeFgabcGabc(utilities_1.fn4)(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabcGabc_1.composeFgabcGabc(utilities_1.fn4)(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgabcGabc_1.composeFgabcGabc(utilities_1.fn4)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(4);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgabcGabc_1.composeFgabcGabc)(utilities_1.fn4)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGabc_1.composeFgabcGabc(utilities_1.identity(utilities_1.fn4))(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFgabcGabc_1.composeFgabcGabc(utilities_1.fn4)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGabc_1.composeFgabcGabc(utilities_1.fn4)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFgabcGabc_1.composeFgabcGabc(utilities_1.fn4)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFgabcGabc_1.composeFgabcGabc(utilities_1.fn4)(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgabcGabc.spec.js.map