"use strict";
exports.__esModule = true;
var composeFgabcGb_1 = require("../composeFgabcGb");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgabcGb_1.composeFgabcGb.length).toStrictEqual(1);
        expect(composeFgabcGb_1.composeFgabcGb(utilities_1.fn4).length).toStrictEqual(1);
        expect(composeFgabcGb_1.composeFgabcGb(utilities_1.fn4)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgabcGb_1.composeFgabcGb(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabcGb_1.composeFgabcGb(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgabcGb_1.composeFgabcGb(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(4);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgabcGb_1.composeFgabcGb)(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGb_1.composeFgabcGb(utilities_1.identity(utilities_1.fn4))(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFgabcGb_1.composeFgabcGb(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGb_1.composeFgabcGb(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFgabcGb_1.composeFgabcGb(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFgabcGb_1.composeFgabcGb(utilities_1.fn4)(utilities_1.fn1)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgabcGb.spec.js.map