"use strict";
exports.__esModule = true;
var composeFgabcGc_1 = require("../composeFgabcGc");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgabcGc_1.composeFgabcGc.length).toStrictEqual(1);
        expect(composeFgabcGc_1.composeFgabcGc(utilities_1.fn4).length).toStrictEqual(1);
        expect(composeFgabcGc_1.composeFgabcGc(utilities_1.fn4)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgabcGc_1.composeFgabcGc(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgabcGc_1.composeFgabcGc(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgabcGc_1.composeFgabcGc(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(4);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgabcGc_1.composeFgabcGc)(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGc_1.composeFgabcGc(utilities_1.identity(utilities_1.fn4))(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c));
    });
    test("Symbol", function () {
        expect(composeFgabcGc_1.composeFgabcGc(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual(composeFgabcGc_1.composeFgabcGc(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c));
        expect(composeFgabcGc_1.composeFgabcGc(utilities_1.fn4)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)(utilities_1.c)).not.toStrictEqual(composeFgabcGc_1.composeFgabcGc(utilities_1.fn4)(utilities_1.fn1)(utilities_1.c)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgabcGc.spec.js.map