"use strict";
exports.__esModule = true;
var composeFgbGa_1 = require("../composeFgbGa");
var utilities_1 = require("./utilities");
describe("Partial Application", function () {
    test("Arity", function () {
        expect(composeFgbGa_1.composeFgbGa.length).toStrictEqual(1);
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b).length).toStrictEqual(2);
    });
});
describe("Referential Transparency", function () {
    test("Equality", function () {
        expect(utilities_1.identity(composeFgbGa_1.composeFgbGa)(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgbGa_1.composeFgbGa(utilities_1.identity(utilities_1.fn2))(utilities_1.fn1)(utilities_1.a)(utilities_1.b));
    });
    test("Symbol", function () {
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).toStrictEqual(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b));
        expect(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.a)(utilities_1.b)).not.toStrictEqual(composeFgbGa_1.composeFgbGa(utilities_1.fn2)(utilities_1.fn1)(utilities_1.b)(utilities_1.a));
    });
});
//# sourceMappingURL=composeFgbGa.spec.js.map