import {composeFa as compose} from "../composeFa";
import {a, b, fn1 as F, identity} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(a).length).toStrictEqual(1);
    });

});

describe("Referential Transparency", () => {

    test("Equality", () => {
        expect(identity(compose)(F)(a)).toStrictEqual(compose(identity(F))(a));
    });

    test("Symbol", () => {
        expect(compose(F)(a)).toStrictEqual(compose(F)(a));
        expect(compose(F)(a)).not.toStrictEqual(compose(F)(b));
    });

});
