import {composeFab as compose} from "../composeFab";
import {a, b, fn2 as F, identity} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(a).length).toStrictEqual(1);
        expect(compose(F)(a)(b).length).toStrictEqual(2);
    });

});

describe("Referential Transparency", () => {

    test("Equality", () => {
        expect(identity(compose)(F)(a)(b)).toStrictEqual(compose(identity(F))(a)(b));
    });

    test("Symbol", () => {
        expect(compose(F)(a)(b)).toStrictEqual(compose(F)(a)(b));
        expect(compose(F)(a)(b)).not.toStrictEqual(compose(F)(b)(a));
    });

});
