import {composeFabc as compose} from "../composeFabc";
import {a, b, c, fn3 as F, identity} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(a).length).toStrictEqual(1);
        expect(compose(F)(a)(b).length).toStrictEqual(1);
        expect(compose(F)(a)(b)(c).length).toStrictEqual(3);
    });

});

describe("Referential Transparency", () => {

    test("Equality", () => {
        expect(identity(compose)(F)(a)(b)(c)).toStrictEqual(compose(identity(F))(a)(b)(c));
    });

    test("Symbol", () => {
        expect(compose(F)(a)(b)(c)).toStrictEqual(compose(F)(a)(b)(c));
        expect(compose(F)(a)(b)(c)).not.toStrictEqual(compose(F)(c)(b)(a));
    });

});
