import {composeFgGa as compose} from "../composeFgGa";
import {a, b, fn1 as F, fn1 as G, identity} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(1);
    });

});

describe("Referential Transparency", () => {

    test("Equality", () => {
        expect(identity(compose)(F)(G)(a)).toStrictEqual(compose(identity(F))(G)(a));
    });

    test("Symbol", () => {
        expect(compose(F)(identity)(a)).toStrictEqual(compose(F)(identity)(a));
        expect(compose(F)(identity)(a)).not.toStrictEqual(compose(F)(identity)(b));
    });

});
