import {composeFgGabc as compose} from "../composeFgGabc";
import {a, b, c, fn1 as F, fn3 as G, identity} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b)(c).length).toStrictEqual(1);
    });

});

describe("Referential Transparency", () => {

    test("Equality", () => {
        expect(identity(compose)(F)(G)(a)(b)(c)).toStrictEqual(compose(identity(F))(G)(a)(b)(c));
    });

    test("Symbol", () => {
        expect(compose(F)(G)(a)(b)(c)).toStrictEqual(compose(F)(G)(a)(b)(c));
        expect(compose(F)(G)(a)(b)(c)).not.toStrictEqual(compose(F)(G)(c)(b)(a));
    });

});
