import {composeFgaGa as compose} from "../composeFgaGa";
import {a, b, fn1 as G, fn2 as F, identity} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(2);
    });

});

describe("Referential Transparency", () => {

    test("Equality", () => {
        expect(identity(compose)(F)(G)(a)).toStrictEqual(compose(identity(F))(G)(a));
    });

    test("Symbol", () => {
        expect(compose(F)(G)(a)).toStrictEqual(compose(F)(G)(a));
        expect(compose(F)(G)(a)).not.toStrictEqual(compose(F)(G)(b));
    });

});
