import {composeFgabGa as compose} from "../composeFgabGa";
import {a, b, fn1 as G, fn3 as F, identity} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b).length).toStrictEqual(3);
    });

});

describe("Referential Transparency", () => {

    test("Equality", () => {
        expect(identity(compose)(F)(G)(a)(b)).toStrictEqual(compose(identity(F))(G)(a)(b));
    });

    test("Symbol", () => {
        expect(compose(F)(G)(a)(b)).toStrictEqual(compose(F)(G)(a)(b));
        expect(compose(F)(G)(a)(b)).not.toStrictEqual(compose(F)(G)(b)(a));
    });

});
